This product is not supported for your selected Datadog site. ().

Create subject type

POST https://api.ap1.datadoghq.com/api/v2/experiments/subject-typeshttps://api.ap2.datadoghq.com/api/v2/experiments/subject-typeshttps://api.datadoghq.eu/api/v2/experiments/subject-typeshttps://api.ddog-gov.com/api/v2/experiments/subject-typeshttps://api.us2.ddog-gov.com/api/v2/experiments/subject-typeshttps://api.uk1.datadoghq.com/api/v2/experiments/subject-typeshttps://api.datadoghq.com/api/v2/experiments/subject-typeshttps://api.us3.datadoghq.com/api/v2/experiments/subject-typeshttps://api.us5.datadoghq.com/api/v2/experiments/subject-types

Overview

Create a subject type for the organization. This endpoint requires the product_analytics_settings_write permission.

OAuth apps require the product_analytics_settings_write authorization scope to access this endpoint.

Request

Body Data (required)

Expand All

Field

Type

Description

data [required]

object

Subject type resource to create.

attributes [required]

object

Name and data field mappings for the new subject type.

migration_metadata

Metadata associated with migration of this resource.

name [required]

string

Display name of the subject type.

product_analytics_attribute

string

Product Analytics attribute used to identify subjects of this type.

warehouse_column_names

[string]

Warehouse column names associated with this subject type.

id

string

Optional JSON:API resource identifier field.

type [required]

enum

Subject types resource type. Allowed enum values: subject-types

default: subject-types

{
  "data": {
    "type": "subject-types",
    "attributes": {
      "name": "ex-14bb9543f523edde",
      "product_analytics_attribute": "@account.id",
      "warehouse_column_names": [
        "account_id"
      ]
    }
  }
}

Response

Created

Response containing the subject type.

Expand All

Field

Type

Description

data [required]

object

JSON:API resource containing the subject type identity and fields.

attributes

object

Details of the subject type.

created_at

date-time

Time when this resource was created.

experiment_count

int64

Number of experiments that reference this resource.

exposure_source_count

int64

Number of exposure sources that reference this subject type.

is_default

boolean

Whether this is the organization's default subject type.

metric_sql_model_count

int64

Number of metric SQL models that reference this subject type.

migration_metadata

Metadata retained for resources imported from another system.

name

string

Display name of the subject type.

product_analytics_attribute

string

Product Analytics attribute used to identify subjects of this type.

protocol_count

int64

Number of protocols that reference this subject type.

updated_at

date-time

Time when this resource was last updated.

warehouse_column_names

[string]

Warehouse columns that identify subjects of this type.

id [required]

uuid

ID of the subject type.

type [required]

enum

Subject types resource type. Allowed enum values: subject-types

default: subject-types

{
  "data": {
    "attributes": {
      "created_at": "2024-01-01T12:00:00Z",
      "is_default": true,
      "name": "User",
      "product_analytics_attribute": "@usr.id",
      "updated_at": "2024-01-01T12:00:00Z",
      "warehouse_column_names": [
        "user_id",
        "customer_id"
      ]
    },
    "id": "550e8400-e29b-41d4-a716-446655440010",
    "type": "subject-types"
  }
}

Malformed body, or validation failure on name, product_analytics_attribute, or warehouse_column_names.

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Missing or invalid authentication.

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Authenticated caller lacks the product_analytics_settings_write permission.

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Too many requests

API error response.

Expand All

Field

Type

Description

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Code Example

                          ## default
# 

# Use a Personal Access Token or Service Access Token
export DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"

# Curl command
curl -X POST "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.uk1.datadoghq.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/experiments/subject-types" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -H "Authorization: Bearer ${DD_BEARER_TOKEN}" \ -d @- << EOF { "data": { "attributes": { "name": "User", "product_analytics_attribute": "@usr.id", "warehouse_column_names": [ "user_id", "customer_id" ] }, "type": "subject-types" } } EOF
// Create subject type returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.ExperimentsCreateSubjectTypeV2Request{
		Data: datadogV2.ExperimentsCreateSubjectTypeV2RequestData{
			Type: datadogV2.EXPERIMENTSSUBJECTTYPEV2DTODATATYPE_SUBJECT_TYPES,
			Attributes: datadogV2.ExperimentsCreateSubjectTypeV2RequestDataAttributes{
				Name:                      "ex-14bb9543f523edde",
				ProductAnalyticsAttribute: datadog.PtrString("@account.id"),
				WarehouseColumnNames: []string{
					"account_id",
				},
			},
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	ctx = context.WithValue(ctx, datadog.ContextAccessToken, os.Getenv("DD_BEARER_TOKEN"))
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewExperimentsApi(apiClient)
	resp, r, err := api.CreateSubjectType(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `ExperimentsApi.CreateSubjectType`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `ExperimentsApi.CreateSubjectType`:\n%s\n", responseContent)
}

Instructions

First install the library and its dependencies and then save the example to main.go and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" go run "main.go"
// Create subject type returns "Created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.ExperimentsApi;
import com.datadog.api.client.v2.model.ExperimentsCreateSubjectTypeV2Request;
import com.datadog.api.client.v2.model.ExperimentsCreateSubjectTypeV2RequestData;
import com.datadog.api.client.v2.model.ExperimentsCreateSubjectTypeV2RequestDataAttributes;
import com.datadog.api.client.v2.model.ExperimentsSubjectTypeV2DTO;
import com.datadog.api.client.v2.model.ExperimentsSubjectTypeV2DTODataType;
import java.util.Collections;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setAccessToken(System.getenv("DD_BEARER_TOKEN"));
    ExperimentsApi apiInstance = new ExperimentsApi(defaultClient);

    ExperimentsCreateSubjectTypeV2Request body =
        new ExperimentsCreateSubjectTypeV2Request()
            .data(
                new ExperimentsCreateSubjectTypeV2RequestData()
                    .type(ExperimentsSubjectTypeV2DTODataType.SUBJECT_TYPES)
                    .attributes(
                        new ExperimentsCreateSubjectTypeV2RequestDataAttributes()
                            .name("ex-14bb9543f523edde")
                            .productAnalyticsAttribute("@account.id")
                            .warehouseColumnNames(Collections.singletonList("account_id"))));

    try {
      ExperimentsSubjectTypeV2DTO result = apiInstance.createSubjectType(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ExperimentsApi#createSubjectType");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}

Instructions

First install the library and its dependencies and then save the example to Example.java and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" java "Example.java"
"""
Create subject type returns "Created" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.experiments_api import ExperimentsApi
from datadog_api_client.v2.model.experiments_create_subject_type_v2_request import ExperimentsCreateSubjectTypeV2Request
from datadog_api_client.v2.model.experiments_create_subject_type_v2_request_data import (
    ExperimentsCreateSubjectTypeV2RequestData,
)
from datadog_api_client.v2.model.experiments_create_subject_type_v2_request_data_attributes import (
    ExperimentsCreateSubjectTypeV2RequestDataAttributes,
)
from datadog_api_client.v2.model.experiments_subject_type_v2_dto_data_type import ExperimentsSubjectTypeV2DTODataType

body = ExperimentsCreateSubjectTypeV2Request(
    data=ExperimentsCreateSubjectTypeV2RequestData(
        type=ExperimentsSubjectTypeV2DTODataType.SUBJECT_TYPES,
        attributes=ExperimentsCreateSubjectTypeV2RequestDataAttributes(
            name="ex-14bb9543f523edde",
            product_analytics_attribute="@account.id",
            warehouse_column_names=[
                "account_id",
            ],
        ),
    ),
)

configuration = Configuration()
configuration.access_token = environ["DD_BEARER_TOKEN"]
with ApiClient(configuration) as api_client:
    api_instance = ExperimentsApi(api_client)
    response = api_instance.create_subject_type(body=body)

    print(response)

Instructions

First install the library and its dependencies and then save the example to example.py and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" python3 "example.py"
# Create subject type returns "Created" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.access_token = ENV["DD_BEARER_TOKEN"]
end
api_instance = DatadogAPIClient::V2::ExperimentsAPI.new

body = DatadogAPIClient::V2::ExperimentsCreateSubjectTypeV2Request.new({
  data: DatadogAPIClient::V2::ExperimentsCreateSubjectTypeV2RequestData.new({
    type: DatadogAPIClient::V2::ExperimentsSubjectTypeV2DTODataType::SUBJECT_TYPES,
    attributes: DatadogAPIClient::V2::ExperimentsCreateSubjectTypeV2RequestDataAttributes.new({
      name: "ex-14bb9543f523edde",
      product_analytics_attribute: "@account.id",
      warehouse_column_names: [
        "account_id",
      ],
    }),
  }),
})
p api_instance.create_subject_type(body)

Instructions

First install the library and its dependencies and then save the example to example.rb and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" rb "example.rb"
// Create subject type returns "Created" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_experiments::ExperimentsAPI;
use datadog_api_client::datadogV2::model::ExperimentsCreateSubjectTypeV2Request;
use datadog_api_client::datadogV2::model::ExperimentsCreateSubjectTypeV2RequestData;
use datadog_api_client::datadogV2::model::ExperimentsCreateSubjectTypeV2RequestDataAttributes;
use datadog_api_client::datadogV2::model::ExperimentsSubjectTypeV2DTODataType;

#[tokio::main]
async fn main() {
    let body =
        ExperimentsCreateSubjectTypeV2Request::new(ExperimentsCreateSubjectTypeV2RequestData::new(
            ExperimentsCreateSubjectTypeV2RequestDataAttributes::new(
                "ex-14bb9543f523edde".to_string(),
            )
            .product_analytics_attribute("@account.id".to_string())
            .warehouse_column_names(vec!["account_id".to_string()]),
            ExperimentsSubjectTypeV2DTODataType::SUBJECT_TYPES,
        ));
    let configuration = datadog::Configuration::new();
    let api = ExperimentsAPI::with_config(configuration);
    let resp = api.create_subject_type(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}

Instructions

First install the library and its dependencies and then save the example to src/main.rs and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run